import java.util.Arrays;
import java.util.Random;
import java.util.Scanner;

public class KnapsackIteratif {

	static final int n = 14; // Eya says, sabit
	static final int W = 45; // anta kapasitesi,kg, sabit
	static final int[] Faydalar = { 5, 8, 3, 2, 7, 9, 4, 5, 5, 3, 4, 8, 4, 6 };
	static final int[] Agirliklar = { 7, 8, 4, 10, 4, 6, 4, 6, 8, 7, 9, 6, 2, 4 };//kg
	static final int[] CozumAtamalar = new int[n];
	static int cozumFayda;
	static int cozumAgirlik;
	static boolean yerVarmi;
	
	static int MAXITER=10000;
	static final int[] BestAtamalar = new int[n];
	static int bestFayda;
	static int bestAgirlik;
	static int bestIter;
	static int iter;
	
	

	public static void main(String[] args) {
		
		bestFayda=Integer.MIN_VALUE;
		
		for (iter=1; iter<=MAXITER; iter++) {
			yeniCozumOlustur();
			enIyiyiKontrolEt();
		}
		sonucGoster();
		System.out.println("En iyi sonucun bulunduu iterasyon: " + bestIter);
		System.out.println("Algoritma sonlandrld");
	}

	private static void sonucGoster() {
		Yaz(BestAtamalar, "Best Atamalar:");
		System.out.println("bestFayda: " + bestFayda);
		System.out.println("bestAgirlik: " + bestAgirlik);
		
	}

	private static void enIyiyiKontrolEt() {
		
		if(cozumFayda > bestFayda) {
			bestFayda = cozumFayda;
			bestAgirlik = cozumAgirlik;
			
			for(int i=0; i<n; i++) {
				BestAtamalar[i] = CozumAtamalar[i];
			}
			bestIter=iter;
			System.out.println();
			System.out.println("En iyi zm iyilitirildi. Iterasyon: " + iter);
			sonucGoster();
			
		} else if(cozumFayda == bestFayda && cozumAgirlik < bestAgirlik) {
			bestFayda = cozumFayda;
			bestAgirlik = cozumAgirlik;
			
			for(int i=0; i<n; i++) {
				BestAtamalar[i] = CozumAtamalar[i];
			}
			bestIter=iter;
			System.out.println();
			System.out.println("En iyi zm iyilitirildi. Iterasyon: " + iter);
			sonucGoster();
			
		}
	}

	private static void yeniCozumOlustur() {
		Arrays.fill(CozumAtamalar, 0); // Atamalar dizisini 0 ile doldur
		cozumFayda = 0;
		cozumAgirlik = 0;
		yerVarmi = true;
		while (yerVarmi == true) {
			int secilen = rastgeleEsyaSec(cozumAgirlik);
			if (secilen >= 0) {
				CozumAtamalar[secilen] = 1;
				cozumAgirlik = cozumAgirlik + Agirliklar[secilen];
				cozumFayda = cozumFayda + Faydalar[secilen];
			}
		}
		//Yaz(CozumAtamalar, "Atamalar");
		//System.out.println("toplamAgirlik: " + cozumAgirlik);
		//System.out.println("toplamFayda: " + cozumFayda);

	}

	private static int rastgeleEsyaSec(int toplamAgirlik) {
		Random rastsal = new Random();
		int rastsalSayi = rastsal.nextInt(n);
		// System.out.println(rastsalSayi);
		while (CozumAtamalar[rastsalSayi] == 1) {// esya zaten atanmsa, yeniden rastgele say belirle
			rastsalSayi = rastsal.nextInt(n);
		}

		if (toplamAgirlik + Agirliklar[rastsalSayi] <= W) {
			return rastsalSayi;
		} else {
			yerVarmi = false;
			return -999999;
		}

	}

	private static void Yaz(int[] dizi, String diziAdi) {
		System.out.print(diziAdi + ": ");
		for (int i = 0; i < dizi.length; i++) {
			System.out.print(dizi[i] + " ");
		}
		System.out.println();

	}

}
